diff --git a/Changelog b/Changelog
index b36a631..6ec4665 100644
--- a/Changelog
+++ b/Changelog
@@ -9,6 +9,7 @@ version <next>:
 - Support for spherical videos
 - configure now fails if autodetect-libraries are requested but not found
 - PSD Decoder
+- support for decoding through D3D11VA in ffmpeg
 
 version 3.2:
 - libopenmpt demuxer
diff --git a/Makefile b/Makefile
index 8aa72fd..7f0da3c 100644
--- a/Makefile
+++ b/Makefile
@@ -37,6 +37,7 @@ ifndef CONFIG_VIDEOTOOLBOX
 OBJS-ffmpeg-$(CONFIG_VDA)     += ffmpeg_videotoolbox.o
 endif
 OBJS-ffmpeg-$(CONFIG_CUVID)   += ffmpeg_cuvid.o
+OBJS-ffmpeg-$(CONFIG_D3D11VA) += ffmpeg_d3d11va.o
 OBJS-ffmpeg-$(HAVE_DXVA2_LIB) += ffmpeg_dxva2.o
 OBJS-ffmpeg-$(HAVE_VDPAU_X11) += ffmpeg_vdpau.o
 OBJS-ffserver                 += ffserver_config.o
diff --git a/ffmpeg.h b/ffmpeg.h
index ebe5bf0..5faf545 100644
--- a/ffmpeg.h
+++ b/ffmpeg.h
@@ -67,6 +67,7 @@ enum HWAccelID {
     HWACCEL_QSV,
     HWACCEL_VAAPI,
     HWACCEL_CUVID,
+    HWACCEL_D3D11VA,
 };
 
 typedef struct HWAccel {
@@ -633,6 +634,7 @@ int ifilter_parameters_from_decoder(InputFilter *ifilter, const AVCodecContext *
 int ffmpeg_parse_options(int argc, char **argv);
 
 int vdpau_init(AVCodecContext *s);
+int d3d11va_init(AVCodecContext *s);
 int dxva2_init(AVCodecContext *s);
 int vda_init(AVCodecContext *s);
 int videotoolbox_init(AVCodecContext *s);
diff --git a/ffmpeg_d3d11va.c b/ffmpeg_d3d11va.c
new file mode 100644
index 0000000..18c3e53
--- /dev/null
+++ b/ffmpeg_d3d11va.c
@@ -0,0 +1,210 @@
+/*
+ * This file is part of FFmpeg.
+ *
+ * FFmpeg is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * FFmpeg is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with FFmpeg; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include <windows.h>
+
+#if !defined(_WIN32_WINNT) || _WIN32_WINNT < 0x0600
+#undef _WIN32_WINNT
+#define _WIN32_WINNT 0x0600
+#endif
+#define COBJMACROS
+
+#include <stdint.h>
+
+#include <d3d11.h>
+
+#include "ffmpeg.h"
+
+#include "libavcodec/d3d11va.h"
+
+#include "libavutil/avassert.h"
+#include "libavutil/buffer.h"
+#include "libavutil/frame.h"
+#include "libavutil/imgutils.h"
+#include "libavutil/pixfmt.h"
+
+#include "libavutil/hwcontext.h"
+#include "libavutil/hwcontext_d3d11va.h"
+
+typedef struct D3D11VAContext {
+    D3D11_VIDEO_DECODER_CONFIG   decoder_config;
+
+    AVFrame                     *tmp_frame;
+
+    AVBufferRef                 *hw_device_ctx;
+    AVBufferRef                 *hw_frames_ctx;
+} D3D11VAContext;
+
+typedef D3D11_VIDEO_DECODER_CONFIG DXVA_DECODER_CONFIG;
+typedef DXGI_FORMAT                DXVA_SURFACE_FORMAT;
+typedef D3D11VAContext             DXVA_CONTEXT;
+typedef AVD3D11VAContext           DXVA_AV_CONTEXT;
+typedef ID3D11VideoDevice          *DXVA_DECODER_SERVICE;
+#include "ffmpeg_directx_va_template.c"
+
+static int d3d11va_get_decoder_configuration(AVCodecContext *s,
+                                             const D3D11_VIDEO_DECODER_DESC *desc,
+                                             D3D11_VIDEO_DECODER_CONFIG *config)
+{
+    InputStream  *ist                    = s->opaque;
+    int loglevel                         = (ist->hwaccel_id == HWACCEL_AUTO) ? AV_LOG_VERBOSE : AV_LOG_ERROR;
+    D3D11VAContext *ctx                    = ist->hwaccel_ctx;
+    AVHWDeviceContext        *device_ctx = (AVHWDeviceContext*)ctx->hw_device_ctx->data;
+    AVD3D11VADeviceContext *device_hwctx = device_ctx->hwctx;
+    unsigned cfg_count;
+    D3D11_VIDEO_DECODER_CONFIG *cfg_list;
+    HRESULT hr;
+    int i, ret;
+
+    hr = ID3D11VideoDevice_GetVideoDecoderConfigCount(device_hwctx->video_device, desc, &cfg_count);
+    if (FAILED(hr)) {
+        av_log(NULL, loglevel, "Unable to retrieve decoder configurations\n");
+        return AVERROR(EINVAL);
+    }
+
+    cfg_list = av_malloc(cfg_count * sizeof(D3D11_VIDEO_DECODER_CONFIG));
+    if (cfg_list == NULL)
+        return AVERROR(ENOMEM);
+    for (i = 0; i < cfg_count; i++) {
+        hr = ID3D11VideoDevice_GetVideoDecoderConfig(device_hwctx->video_device, desc, i, &cfg_list[i]);
+        if (FAILED(hr)) {
+            av_log(NULL, loglevel, "Unable to retrieve decoder configurations. (hr=0x%lX)\n", hr);
+            free(cfg_list);
+            return AVERROR(EINVAL);
+        }
+    }
+
+    ret = dxva_get_decoder_configuration(s, cfg_list, cfg_count, config);
+    av_free(cfg_list);
+    return ret;
+}
+
+static int d3d11va_validate_output(ID3D11VideoDevice *service, GUID guid, DXGI_FORMAT surface_format)
+{
+    HRESULT hr;
+    BOOL is_supported = FALSE;
+    hr = ID3D11VideoDevice_CheckVideoDecoderFormat(service, &guid, surface_format, &is_supported);
+    return SUCCEEDED(hr) && is_supported;
+}
+
+static int d3d11va_create_decoder(AVCodecContext *s)
+{
+    InputStream  *ist = s->opaque;
+    int loglevel = (ist->hwaccel_id == HWACCEL_AUTO) ? AV_LOG_VERBOSE : AV_LOG_ERROR;
+    D3D11VAContext *ctx = ist->hwaccel_ctx;
+    AVD3D11VAContext *dxva_ctx = s->hwaccel_context;
+    GUID *guid_list;
+    unsigned guid_count, i;
+    GUID device_guid;
+    const DXGI_FORMAT surface_format = s->sw_pix_fmt == AV_PIX_FMT_YUV420P10 ?
+                                       DXGI_FORMAT_P010 : DXGI_FORMAT_NV12;
+    D3D11_VIDEO_DECODER_DESC desc = { 0 };
+    D3D11_VIDEO_DECODER_CONFIG config;
+    HRESULT hr;
+    int ret;
+
+    AVD3D11VAFramesContext *frames_hwctx;
+    AVHWFramesContext *frames_ctx;
+
+    AVHWDeviceContext    *device_ctx;
+    AVD3D11VADeviceContext *device_hwctx;
+    device_ctx = (AVHWDeviceContext*)ctx->hw_device_ctx->data;
+    device_hwctx = device_ctx->hwctx;
+
+    guid_count = ID3D11VideoDevice_GetVideoDecoderProfileCount(device_hwctx->video_device);
+    guid_list = av_malloc(sizeof(*guid_list) * guid_count);
+    if (guid_list==NULL) {
+        av_log(NULL, loglevel, "Failed to get the decoder GUIDs\n");
+        goto fail;
+    }
+    for (i=0; i<guid_count; i++) {
+        hr = ID3D11VideoDevice_GetVideoDecoderProfile(device_hwctx->video_device, i, &guid_list[i]);
+        if (FAILED(hr)) {
+            av_log(NULL, loglevel, "Failed to retrieve decoder GUID %d\n", i);
+            av_free(guid_list);
+            goto fail;
+        }
+    }
+
+    ret = dxva_get_decoder_guid(s, device_hwctx->video_device, surface_format, d3d11va_validate_output,
+                                guid_count, guid_list, &device_guid);
+    av_free(guid_list);
+    if (ret < 0) {
+        goto fail;
+    }
+
+    desc.SampleWidth  = s->coded_width;
+    desc.SampleHeight = s->coded_height;
+    desc.OutputFormat = surface_format;
+    desc.Guid         = device_guid;
+
+    ret = d3d11va_get_decoder_configuration(s, &desc, &config);
+    if (ret < 0) {
+        goto fail;
+    }
+
+    ctx->hw_frames_ctx = av_hwframe_ctx_alloc(ctx->hw_device_ctx);
+    if (!ctx->hw_frames_ctx)
+        goto fail;
+    frames_ctx   = (AVHWFramesContext*)ctx->hw_frames_ctx->data;
+    frames_hwctx = frames_ctx->hwctx;
+    frames_ctx->format = AV_PIX_FMT_D3D11VA_VLD;
+
+    dxva_adjust_decoder(s);
+
+    hr = ID3D11VideoDevice_CreateVideoDecoder(device_hwctx->video_device, &desc,
+                                              &config, &frames_hwctx->decoder_to_release);
+    if (FAILED(hr)) {
+        av_log(NULL, loglevel, "Failed to create D3D11VA video decoder\n");
+        goto fail;
+    }
+
+    ret = av_hwframe_ctx_init(ctx->hw_frames_ctx);
+    if (ret < 0) {
+        av_log(NULL, loglevel, "Failed to initialize the HW frames context\n");
+        goto fail;
+    }
+
+    ctx->decoder_config = config;
+
+    dxva_ctx->cfg           = &ctx->decoder_config;
+    dxva_ctx->decoder       = frames_hwctx->decoder_to_release;
+    dxva_ctx->surface       = frames_hwctx->surfaces;
+    dxva_ctx->surface_count = frames_hwctx->nb_surfaces;
+    dxva_ctx->context_mutex = frames_hwctx->dev_ctx_mutex;
+    dxva_ctx->video_context = device_hwctx->video_context;
+
+    return 0;
+fail:
+    av_buffer_unref(&ctx->hw_frames_ctx);
+    return AVERROR(EINVAL);
+}
+
+int d3d11va_init(AVCodecContext *s)
+{
+    InputStream *ist = s->opaque;
+    int ret;
+
+    if (!ist->hwaccel_ctx) {
+        ret = dxva_alloc(s, AV_HWDEVICE_TYPE_D3D11VA);
+        if (ret < 0)
+            return ret;
+    }
+
+    return dxva_init(s, d3d11va_create_decoder);
+}
diff --git a/ffmpeg_opt.c b/ffmpeg_opt.c
index 6862456..238ae51 100644
--- a/ffmpeg_opt.c
+++ b/ffmpeg_opt.c
@@ -69,6 +69,9 @@ const HWAccel hwaccels[] = {
 #if HAVE_VDPAU_X11
     { "vdpau", vdpau_init, HWACCEL_VDPAU, AV_PIX_FMT_VDPAU },
 #endif
+#if CONFIG_D3D11VA
+    { "d3d11va", d3d11va_init, HWACCEL_D3D11VA, AV_PIX_FMT_D3D11VA_VLD },
+#endif
 #if HAVE_DXVA2_LIB
     { "dxva2", dxva2_init, HWACCEL_DXVA2, AV_PIX_FMT_DXVA2_VLD },
 #endif